using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.PaymentReceive.Cqrs;

public record DeletePaymentReceiveByIdCommand(string Id) : IRequest<bool>;

public class DeletePaymentReceiveByIdHandler : IRequestHandler<DeletePaymentReceiveByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeletePaymentReceiveByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeletePaymentReceiveByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.PaymentReceive
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.PaymentReceive.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}